const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Teacher_attendanceDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const teacher_attendance = await db.teacher_attendance.create(
      {
        id: data.id || undefined,

        date: data.date || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await teacher_attendance.setTeacher(data.teacher || null, {
      transaction,
    });

    await teacher_attendance.setSchool(data.school || null, {
      transaction,
    });

    await teacher_attendance.setSchools(data.schools || null, {
      transaction,
    });

    return teacher_attendance;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const teacher_attendanceData = data.map((item, index) => ({
      id: item.id || undefined,

      date: item.date || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const teacher_attendance = await db.teacher_attendance.bulkCreate(
      teacher_attendanceData,
      { transaction },
    );

    // For each item created, replace relation files

    return teacher_attendance;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const teacher_attendance = await db.teacher_attendance.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.date !== undefined) updatePayload.date = data.date;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await teacher_attendance.update(updatePayload, { transaction });

    if (data.teacher !== undefined) {
      await teacher_attendance.setTeacher(
        data.teacher,

        { transaction },
      );
    }

    if (data.school !== undefined) {
      await teacher_attendance.setSchool(
        data.school,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await teacher_attendance.setSchools(
        data.schools,

        { transaction },
      );
    }

    return teacher_attendance;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const teacher_attendance = await db.teacher_attendance.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of teacher_attendance) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of teacher_attendance) {
        await record.destroy({ transaction });
      }
    });

    return teacher_attendance;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const teacher_attendance = await db.teacher_attendance.findByPk(
      id,
      options,
    );

    await teacher_attendance.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await teacher_attendance.destroy({
      transaction,
    });

    return teacher_attendance;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const teacher_attendance = await db.teacher_attendance.findOne(
      { where },
      { transaction },
    );

    if (!teacher_attendance) {
      return teacher_attendance;
    }

    const output = teacher_attendance.get({ plain: true });

    output.teacher = await teacher_attendance.getTeacher({
      transaction,
    });

    output.school = await teacher_attendance.getSchool({
      transaction,
    });

    output.schools = await teacher_attendance.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.teachers,
        as: 'teacher',

        where: filter.teacher
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.teacher
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  full_name: {
                    [Op.or]: filter.teacher
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.schools,
        as: 'school',
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              date: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              date: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.dateRange) {
        const [start, end] = filter.dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.school) {
        const listItems = filter.school.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolId: { [Op.or]: listItems },
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.teacher_attendance.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('teacher_attendance', 'teacher', query),
        ],
      };
    }

    const records = await db.teacher_attendance.findAll({
      attributes: ['id', 'teacher'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['teacher', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.teacher,
    }));
  }
};
